#*************************************************************
# Progamm:			absorption
# Sinn des Programms: 		Berechnung der Absorption in einer homogenen Schicht
# Sinn der Einheit  :		Berechnung der Intensität in Abhängigkeit der 
#				durchquerten Schicht	
# Name dieser Datei:		rechner.py
# Versionsnummer:		1
# Wird aufgerufen von:		absorption_1d_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	4
# von:				6			
# Autor: 			Armin Ulrich
# Erster Lauf: 			12.07.2018
# Letzte Änderung: 		04.11.2018
#*************************************************************

#*************************************************************
# Importieren der Klassen für Dateifunktionen
#*************************************************************
#import os

import math
#import matplotlib as mlp
#import matplotlib.pyplot as plt

class Rechner:

  def __init__(self):		
    print("Rechnerobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Rechnerobjekt entfernt")          

 


  def euler(self,Intens_init, kappa, i_max, x, delta_x):
    print("Eulerverfahren",Intens_init, kappa)
    self.Intens = list(range(i_max))
    self.Intens[0]=Intens_init
    for i in range(i_max-1):
      self.Intens[i+1]=self.Intens[i]*(1.0-kappa*delta_x[i])    
      print(i,self.Intens[i])
    self.Intens_absorbiert = Intens_init - self.Intens[i_max-1]
    print("Restintensität:",self.Intens[i_max-1],"Absorbierte Intensität:",self.Intens_absorbiert)

  def analyt(self,Intens_init, kappa, i_max, x, delta_x):
    print("analytische Lösung")
    self.Intens_analyt = list(range(i_max))
    self.Intens_analyt[0]=Intens_init
    for i in range(i_max):
      self.Intens_analyt[i]=self.Intens_analyt[0]*math.exp(-kappa*x[i])
      print(i,self.Intens_analyt[i])
    

  
